Bug 1798524 (CVE-2019-20444) - CVE-2019-20444 netty: HTTP request smuggling
Summary: CVE-2019-20444 netty: HTTP request smuggling
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2019-20444
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
high
high
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1798525 1798769 1798770 1798771 1798772 1798773
Blocks: 1798529
TreeView+ depends on / blocked
 
Reported: 2020-02-05 14:39 UTC by Dhananjay Arunesh
Modified: 2020-05-28 16:00 UTC (History)
87 users (show)

Fixed In Version: netty 4.1.44
Doc Type: If docs needed, set a value
Doc Text:
A HTTP smuggling flaw was found in HttpObjectDecoder.java in Netty in versions prior to version 4.1.44. HTTP headers with an invalid fold, in this case CRLF (carriage return, line feed) without being followed by SP (space) or HTAB (horizontal tab), result in situations where headers can be misread. Data integrity is the highest threat with this vulnerability.
Clone Of:
Environment:
Last Closed: 2020-02-13 20:09:52 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2020:0497 None None None 2020-02-13 14:51:14 UTC
Red Hat Product Errata RHSA-2020:0567 None None None 2020-03-03 16:13:26 UTC
Red Hat Product Errata RHSA-2020:0601 None None None 2020-02-25 15:30:39 UTC
Red Hat Product Errata RHSA-2020:0804 None None None 2020-03-12 17:04:48 UTC
Red Hat Product Errata RHSA-2020:0805 None None None 2020-03-12 17:06:28 UTC
Red Hat Product Errata RHSA-2020:0806 None None None 2020-03-12 17:01:54 UTC
Red Hat Product Errata RHSA-2020:0811 None None None 2020-03-12 17:00:54 UTC
Red Hat Product Errata RHSA-2020:0922 None None None 2020-03-23 08:23:34 UTC
Red Hat Product Errata RHSA-2020:0939 None None None 2020-03-23 13:21:24 UTC
Red Hat Product Errata RHSA-2020:0951 None None None 2020-03-23 20:14:18 UTC
Red Hat Product Errata RHSA-2020:1445 None None None 2020-04-14 13:05:43 UTC
Red Hat Product Errata RHSA-2020:2321 None None None 2020-05-26 16:10:23 UTC
Red Hat Product Errata RHSA-2020:2333 None None None 2020-05-28 16:00:01 UTC

Description Dhananjay Arunesh 2020-02-05 14:39:56 UTC
A vulnerability was found in HttpObjectDecoder.java in Netty before 4.1.44 allows an HTTP header that lacks a colon, which might be interpreted as a separate header with an incorrect syntax, or might be interpreted as an "invalid fold."

Reference:
https://github.com/netty/netty/issues/9866
https://github.com/netty/netty/compare/netty-4.1.43.Final...netty-4.1.44.Final

Comment 1 Dhananjay Arunesh 2020-02-05 14:40:52 UTC
Created netty tracking bugs for this issue:

Affects: fedora-all [bug 1798525]

Comment 9 Jonathan Christison 2020-02-13 12:14:23 UTC
Mitigation:

* Use HTTP/2 instead (clear boundaries between requests)
* Disable reuse of backend connections eg. ```http-reuse never``` in HAProxy or whatever equivalent LB settings

Comment 11 errata-xmlrpc 2020-02-13 14:51:09 UTC
This issue has been addressed in the following products:

  Red Hat AMQ Online 1.3.3 GA

Via RHSA-2020:0497 https://access.redhat.com/errata/RHSA-2020:0497

Comment 12 Product Security DevOps Team 2020-02-13 20:09:52 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2019-20444

Comment 17 Eric Christensen 2020-02-21 19:53:20 UTC
External References:

https://github.com/elastic/elasticsearch/issues/49396

Comment 18 errata-xmlrpc 2020-02-25 15:30:36 UTC
This issue has been addressed in the following products:

  AMQ Clients 2.y for RHEL 7
  AMQ Clients 2.y for RHEL 8
  AMQ Clients 2.y for RHEL 6

Via RHSA-2020:0601 https://access.redhat.com/errata/RHSA-2020:0601

Comment 19 Cedric Buissart 🐶 2020-02-28 08:11:04 UTC
Statement:

OpenShift Container Platform ships a vulnerable netty library as part of the logging-elasticsearch5 container. ElasticSearch's security team has stated that the previous vulnerability, CVE-2019-16869, does not pose a substantial practical threat to ElasticSearch 6. We agree that these issues would be difficult to exploit on OpenShift Container Platform so we're reducing the impact of this issue to moderate and may fix it in the future release.

Red Hat Satellite ships a vulnerable version of netty embedded in Candlepin. However, the flaw can not be triggered in that context, because HTTP requests are handled by Tomcat, not by netty. A future release may fix this.

Comment 23 errata-xmlrpc 2020-03-03 16:13:23 UTC
This issue has been addressed in the following products:

  Red Hat Openshift Application Runtimes

Via RHSA-2020:0567 https://access.redhat.com/errata/RHSA-2020:0567

Comment 25 Jonathan Christison 2020-03-12 15:32:10 UTC
Marking AMQ-6 as low as it only uses netty in the context of integration tests, activemq components do not directly rely upon netty.

Comment 27 errata-xmlrpc 2020-03-12 17:00:50 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform

Via RHSA-2020:0811 https://access.redhat.com/errata/RHSA-2020:0811

Comment 28 errata-xmlrpc 2020-03-12 17:01:50 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 8

Via RHSA-2020:0806 https://access.redhat.com/errata/RHSA-2020:0806

Comment 29 errata-xmlrpc 2020-03-12 17:04:44 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 6

Via RHSA-2020:0804 https://access.redhat.com/errata/RHSA-2020:0804

Comment 30 errata-xmlrpc 2020-03-12 17:06:22 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 7

Via RHSA-2020:0805 https://access.redhat.com/errata/RHSA-2020:0805

Comment 31 errata-xmlrpc 2020-03-23 08:23:23 UTC
This issue has been addressed in the following products:

  Red Hat AMQ

Via RHSA-2020:0922 https://access.redhat.com/errata/RHSA-2020:0922

Comment 32 errata-xmlrpc 2020-03-23 13:21:19 UTC
This issue has been addressed in the following products:

  Red Hat JBoss AMQ

Via RHSA-2020:0939 https://access.redhat.com/errata/RHSA-2020:0939

Comment 33 errata-xmlrpc 2020-03-23 20:14:13 UTC
This issue has been addressed in the following products:

  Red Hat Single Sign-On

Via RHSA-2020:0951 https://access.redhat.com/errata/RHSA-2020:0951

Comment 34 errata-xmlrpc 2020-04-14 13:05:39 UTC
This issue has been addressed in the following products:

  Red Hat AMQ 7.4.3

Via RHSA-2020:1445 https://access.redhat.com/errata/RHSA-2020:1445

Comment 35 errata-xmlrpc 2020-05-26 16:10:18 UTC
This issue has been addressed in the following products:

  Red Hat Data Grid 7.3.6

Via RHSA-2020:2321 https://access.redhat.com/errata/RHSA-2020:2321

Comment 36 errata-xmlrpc 2020-05-28 15:59:57 UTC
This issue has been addressed in the following products:

  EAP-CD 19 Tech Preview

Via RHSA-2020:2333 https://access.redhat.com/errata/RHSA-2020:2333


Note You need to log in before you can comment on or make changes to this bug.